<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Annotations</TITLE>
<link href="suif1_70.html" rel=Next>
<link href="suif1_68.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_68.html">previous</A>, <A HREF="suif1_70.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC69" HREF="suif1_toc.html#TOC69">Annotations</A></H1>
<P>
<A NAME="IDX542"></A>
<A NAME="IDX543"></A>

</P>
<P>
Because it is a research compiler, SUIF is designed to be both flexible
and extensible.  <STRONG>Annotations</STRONG>, which may contain arbitrary data
structures, are the primary means of providing this extensibility.
Objects that are derived from the <CODE>suif_object</CODE> class have lists of
annotations associated with them.  This includes most of the major SUIF
objects such as instructions, tree nodes, symbols, types, symbol tables,
and file set entries.  New annotations can be declared by any program
and used to record whatever information is needed within that program.
They can also be written to the SUIF output files so that other programs
can use them.  The <STRONG>annotation manager</STRONG> records the annotation names
and the format of the data associated with each kind of annotation.

</P>

<UL>
<LI><A HREF="suif1_70.html#SEC70">Annotation Overview</A>: Brief description of annotations.
<LI><A HREF="suif1_71.html#SEC71">Flat Annotes</A>: Lists of <CODE>immed</CODE> values.
<LI><A HREF="suif1_72.html#SEC72">Structured Annotes</A>: User-defined data structures in annotations.
<LI><A HREF="suif1_73.html#SEC73">Unregistered Annotes</A>: Annotations not registered with the manager.
<LI><A HREF="suif1_74.html#SEC74">Predefined Annotes</A>: Annotations defined in the SUIF library.
<LI><A HREF="suif1_79.html#SEC79">Annotation Manager</A>: Keeping track of the registered annotations.
<LI><A HREF="suif1_83.html#SEC83">SUIF Objects</A>: Base class for objects with annotations.
<LI><A HREF="suif1_84.html#SEC84">Annote Lists</A>: Handling lists of annotations.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_68.html">previous</A>, <A HREF="suif1_70.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
